<?php

/*
=====================================================
 File: mcp.mainlink.php
-----------------------------------------------------
 Purpose: Mainlink class - CP
=====================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}

class Mainlink_CP {

    var $version = '1.0';
    
    /** -------------------------
    /** Constructor
    /** -------------------------*/
    
    function Mainlink_CP( $switch = TRUE )
    {
        global $IN, $DB;
        
        $query = $DB->query("SELECT module_version FROM exp_modules WHERE module_name = 'Mainlink'");
        
        if ($query->num_rows == 0)
        {
        	return;
        }
        
        /* Is the version current? */
        
        if ($query->row['module_version'] != $this->version)
        {
        	$DB->query("UPDATE exp_modules SET module_version = '{$this->version}' WHERE module_name = 'Mainlink'");
        }

        if ($switch)
        {
            if (method_exists($this, $IN->GBL('P')))
			{	
				$this->{$IN->GBL('P')}();
			}
			else
			{
				$this->mainlink_home();
			}
        }
    }
    /** END */

    /** -------------------------
    /**  Module Homepage
    /** -------------------------*/

    function mainlink_home($msg = '')
    {
        global $DSP, $LANG, $PREFS;

        $DSP->title = $LANG->line('mainlink_module_name');
        $DSP->crumb = $LANG->line('mainlink_module_name');

        if ($msg != '')
        {
			$DSP->body .= $DSP->qdiv('successBox', $DSP->qdiv('success', $msg));
        }

        $DSP->body .= $DSP->form_open(array('action' => 'C=modules'.AMP.'M=mainlink'.AMP.'P=save_settings'));
        $DSP->body .= $DSP->qdiv('tableHeadingAlt', $LANG->line('mainlink_configurations')).
                      $DSP->table('tableBorder', '0', '0', '100%');

        $i = 0;
		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->tr().
					  $DSP->table_qcell($style, $DSP->qdiv('defaultBold', $LANG->line('mainlink_ip')), '50%').
					  $DSP->table_qcell($style,
					  					$DSP->input_text('ml_mainlink_ip', $PREFS->ini('ml_mainlink_ip')),
					  					'50%').
                      $DSP->tr_c();

		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->tr().
					  $DSP->table_qcell($style, $DSP->qdiv('defaultBold', $LANG->line('remote_addr')), '50%').
					  $DSP->table_qcell($style,
					  					$DSP->input_text('ml_remote_addr', $PREFS->ini('ml_remote_addr')),
					  					'50%').
                      $DSP->tr_c();

		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->tr().
					  $DSP->table_qcell($style, $DSP->qdiv('defaultBold', $LANG->line('mainlink_host_name')), '50%').
					  $DSP->table_qcell($style,
					  					$DSP->input_text('ml_mainlink_host_name', $PREFS->ini('ml_mainlink_host_name')),
					  					'50%').
                      $DSP->tr_c();

		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->tr().
					  $DSP->table_qcell($style, $DSP->qdiv('defaultBold', $LANG->line('link_charset')), '50%').
					  $DSP->table_qcell($style,
					  					$DSP->input_select_header('ml_link_charset')
					  					.$DSP->input_select_option('', '',
                                                            ($PREFS->ini('ml_link_charset') == '') ? 1 : 0)
                                        .$DSP->input_select_option('windows-1251', 'windows-1251',
                                                            ($PREFS->ini('ml_link_charset') == 'windows-1251') ? 1 : 0)
                                        .$DSP->input_select_option('koi8-r', 'koi8-r',
                                                            ($PREFS->ini('ml_link_charset') == 'koi8-r') ? 1 : 0)
                                        .$DSP->input_select_option('utf-8', 'utf-8',
                                                            ($PREFS->ini('ml_link_charset') == 'utf-8') ? 1 : 0)
                                        .$DSP->input_select_footer(),
					  					'50%').
                      $DSP->tr_c();

		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->tr().
					  $DSP->table_qcell($style, $DSP->qdiv('defaultBold', $LANG->line('connect_mainlink')), '50%').
					  $DSP->table_qcell($style,
					  					$DSP->input_select_header('ml_connect_mainlink')
					  					.$DSP->input_select_option(1, 'file_get_contents',
                                                            ($PREFS->ini('ml_connect_mainlink') == 1) ? 1 : 0)
                                        .$DSP->input_select_option(2, 'curl',
                                                            ($PREFS->ini('ml_connect_mainlink') == 2) ? 1 : 0)
                                        .$DSP->input_select_option(3, 'socket',
                                                            ($PREFS->ini('ml_connect_mainlink') == 3) ? 1 : 0)
                                        .$DSP->input_select_footer(),
					  					'50%').
                      $DSP->tr_c();

		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->tr().
					  $DSP->table_qcell($style, $DSP->qdiv('defaultBold', $LANG->line('connect_timeout')), '50%').
					  $DSP->table_qcell($style,
					  					$DSP->input_text('ml_connect_timeout', $PREFS->ini('ml_connect_timeout')),
					  					'50%').
                      $DSP->tr_c();

		$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';
		$DSP->body .= $DSP->tr().
					  $DSP->table_qcell($style, $DSP->qdiv('defaultBold', $LANG->line('refresh_data')), '50%').
					  $DSP->table_qcell($style,
					  					$DSP->input_text('ml_refresh_data', $PREFS->ini('ml_refresh_data')),
					  					'50%').
                      $DSP->tr_c();

		$DSP->body .= $DSP->table_c().BR.
					  $DSP->qdiv('itemWrapper',
					  			 $DSP->input_submit($LANG->line('submit'),'submit')).
					  $DSP->form_close();
    }
    /** END */

    /** --------------------------------
    /**  Save settings
    /** --------------------------------*/

    function save_settings()
    {
        global $PREFS, $LANG;

        if ( ! isset($_POST['submit']))
		{
			return $this->mainlink_home();
		}

        $prefs = array('mainlink_ip','remote_addr','mainlink_host_name','link_charset',
                       'connect_mainlink','connect_timeout','refresh_data');

        $insert = array();

		foreach($prefs as $val)
		{
			if (isset($_POST['ml_'.$val]))
			{
                $insert['ml_'.$val] = $_POST['ml_'.$val];
			}
		}
		
		if (sizeof($insert) == 0)
		{
			return $this->mainlink_home();
		}

		if ( ! class_exists('Admin'))
		{
			require PATH_CP.'cp.admin'.EXT;
		}

		Admin::update_config_file($insert);

		$PREFS->core_ini = array_merge($PREFS->core_ini, $insert);

		return $this->mainlink_home($LANG->line('settings_updated'));
    }
    /** END */

    /** --------------------------------
    /**  Module installer
    /** --------------------------------*/

    function mainlink_module_install()
    {
        global $DB;

        $sql[] = "INSERT INTO exp_modules (module_id, module_name, module_version, has_cp_backend)
                                   VALUES ('', 'Mainlink', '$this->version', 'y')";

        $sql[] = "CREATE TABLE exp_mainlink_links (
                    links_id VARCHAR( 50 ) NOT NULL, links_data TEXT NOT NULL,
                    links_dt VARCHAR( 15 ) NOT NULL,
                    UNIQUE KEY links_id (links_id))";

        foreach ($sql as $query)
        {
            $DB->query($query);
        }

        /** ----------------------------------------
		/**  Add a couple items to the config file
		/** ----------------------------------------*/
	  
		if ( ! class_exists('Admin'))
		{
			require PATH_CP.'cp.admin'.EXT;
		}
		
		Admin::append_config_file(array('ml_mainlink_ip' => '89.249.18.60',
                                        'ml_remote_addr' => '88.214.208.19',
                                        'ml_mainlink_host_name' => 'universal.mainlink.ru',
                                        'ml_link_charset' => '',
                                        'ml_connect_mainlink' => '',
                                        'ml_connect_timeout' => '',
                                        'ml_refresh_data' => '',
                                        'ml_version' => $this->version));

        return true;
    }
    /** END */

    /** -------------------------
    /**  Module de-installer
    /** -------------------------*/

    function mainlink_module_deinstall()
    {
        global $DB;

        $query = $DB->query("SELECT module_id FROM exp_modules WHERE module_name = 'Mainlink'");

        $sql[] = "DELETE FROM exp_module_member_groups WHERE module_id = '".$query->row['module_id']."'";
        $sql[] = "DELETE FROM exp_modules WHERE module_name = 'Mainlink'";
        $sql[] = "DELETE FROM exp_actions WHERE class = 'Mainlink'";
        $sql[] = "DROP TABLE IF EXISTS exp_mainlink_links";

        foreach ($sql as $query)
        {
            $DB->query($query);
        }

        /** ----------------------------------------
		/**  Remove a couple items to the config file
		/** ----------------------------------------*/
	  
		if ( ! class_exists('Admin'))
		{
			require PATH_CP.'cp.admin'.EXT;
		}
		
		Admin::append_config_file('', array('ml_mainlink_ip','ml_remote_addr','ml_mainlink_host_name',
                                            'ml_link_charset','ml_connect_mainlink','ml_connect_timeout',
                                            'ml_refresh_data','ml_version'));

        return true;
    }
    /** END */
}
/** END CLASS */
?>