<?php

/*
=====================================================
 File: mod.mainlink.php
-----------------------------------------------------
 Purpose: Mainlink class
=====================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}


class Mainlink {

    var $host = '';
    var $uri = '';
    var $return_data = '';

    var $version = '';
    var $mainlink_ip = '';
    var $remote_addr = '';
    var $mainlink_host_name = '';
    var $link_charset = '';
    var $connect_mainlink = '';
    var $refresh_data = '';
    var $connect_timeout = '';

    function Mainlink()
    {
        global $PREFS;

        $this->host = $_SERVER['HTTP_HOST'];

        $prefs = array('mainlink_ip','remote_addr','mainlink_host_name','link_charset',
                       'connect_mainlink','connect_timeout','refresh_data','version');

        foreach($prefs as $val)
		{
			$this->$val = $PREFS->ini('ml_'.$val);
		}
    }

    function _file_get_contents($request)
    {
        @ini_set('allow_url_fopen','On');
        if(function_exists('file_get_contents') && ini_get('allow_url_fopen'))
        {
            @ini_set('default_socket_timeout',($this->connect_timeout?$this->connect_timeout:5));
            $li = @file_get_contents($request, true);
            if(strstr(strtolower($http_response_header[0]),'http/'))list(,$STATUS)=split(' ',$http_response_header[0]);
            $STATUS=trim($STATUS);
            return array($li,$STATUS);
        }
        else
        {
            return array('',0);
        }
    }

    function _get_curl($request)
    {
        $ch = @curl_init();
        if($ch)
        {
                    curl_setopt ($ch, CURLOPT_URL,$request);
                    curl_setopt ($ch, CURLOPT_HEADER,0);
                    curl_setopt ($ch, CURLOPT_RETURNTRANSFER,1);
                    @curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,($this->connect_timeout?$this->connect_timeout:5));
                    $li = curl_exec ($ch);
                    $status = array();
                    $status = @curl_getinfo($ch);
                    curl_close($ch);
                    return array($li,$status['http_code']);
        }
        else
        {
            return array('',0);
        }
    }

    function _get_socket($request)
    {
        $so=@fsockopen($this->mainlink_host_name, 80, $errno, $errstr, ($this->connect_timeout?$this->connect_timeout:5));
        if($so)
        {
            @fwrite($so, $request);
            while($line!="\r\n")
            {
                $line=@fgets($so);
                if(!$code)
                {
                    if(strstr(strtolower($line),'http/'))list(,$code)=split(' ',$line);
                    $code=trim($code);
                }
            }
            while(!feof($so))$li.=@fgets($so);
            $status = socket_get_status($so);
            if($status['unread_bytes'] == 0 && $status['timed_out'] != 1)
            {
                return array($li,$code);
            }
            else
            {
                return array('',0);
            }
        }
        else
        {
            return array('',0);
        }
    }
    
    function _load()
    {
        global $DB;

        switch($this->connect_mainlink)
        {
            case 1: // file_get_contents
                $request = 'http://'.$this->mainlink_host_name.'/l.aspx?u='.$this->uri.($this->link_charset?'&cs='.$this->link_charset:'');
                $load_data = $this->_file_get_contents($request);
            break;

            case 2: // curl
                $request = 'http://'.$this->mainlink_host_name.'/l.aspx?u='.$this->uri.($this->link_charset?'&cs='.$this->link_charset:'');
                $load_data = $this->_get_curl($request);
            break;

            default: // socket
                $request = "GET /l.aspx?u=".$this->uri.($this->link_charset?"&cs=".$this->link_charset:'')." HTTP/1.1\r\nHost: ".$this->mainlink_host_name."\r\nConnection: Close\r\n\r\n";
                $load_data = $this->_get_socket($request);
            break;
        }

        list($str_uri,$STATUS) = $load_data;
        if(($STATUS==200 and (substr($str_uri,1,6)=='<html>'?1:0)) or (!$str_uri and $STATUS!=200))
        {
            return 0;
		}
        else
        {
            if ($str_uri)
            {
                $regx_array = explode(' | ',$str_uri);
                foreach ($regx_array as $value)
                {
                    preg_match("#(?:href)=['\"]?([^'\"]+)['\"]>([^<]+)?#",$value, $matches);
                    $result[] = array(
                                'uri' => $matches[1],
                                'name' => $matches[2]);
                }

                $query_load = $DB->query("SELECT links_id, links_data, links_dt 
                                        FROM exp_mainlink_links
                                        WHERE links_id = '".hexdec(crc32($this->uri))."'");

                if ($query_load->num_rows > 0)
                {
                    $data = array('links_data' => serialize($result), 'links_dt' => time());

                    $sql = $DB->update_string('exp_mainlink_links', $data, "links_id = ".hexdec(crc32($this->uri)));
                    $DB->query($sql);
                    return 1;
                }
                else
                {
                    $data = array('links_id' => hexdec(crc32($this->uri)), 'links_data' => serialize($result),
                                'links_dt' => time());

                    $sql = $DB->insert_string('exp_mainlink_links', $data);
                    $DB->query($sql);
                    return 1;
                }
            }
            else
            {
                return 0;
            }
        }
    }

    function view()
    {
        global $DB, $TMPL;

        if($this->remote_addr===$_SERVER['REMOTE_ADDR'])return "<!-- $_SERVER[REMOTE_ADDR].$this->version -->";

        $this->uri = urlencode(urldecode($this->host.(isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : $HTTP_SERVER_VARS['REQUEST_URI'])));

        if (strlen(session_id()) > 0) {
            $session = session_name()."=".session_id();
            $this->uri = str_replace(array('?'.$session,'&'.$session), '', $this->uri);
        }

        $query_ver = $DB->query("SELECT links_id, links_data, links_dt 
                    FROM exp_mainlink_links
                    WHERE links_id = '".hexdec(crc32($this->uri))."'");

        if ($query_ver->num_rows > 0)
        {
            if ((time()-$query_ver->row['links_dt']) > (($this->refresh_data?$this->refresh_data:2)*3600))
            {
                if(!$this->_load())
                {
                    return;
                }
                else
                {
                    $query_data = $DB->query("SELECT links_data 
                                    FROM exp_mainlink_links
                                    WHERE links_id = '".hexdec(crc32($this->uri))."'");

                    $data_uri = unserialize($query_data->row['links_data']);
                }
            }
            else
            {
                $data_uri = unserialize($query_ver->row['links_data']);
            }
        }
        else
        {
            if($this->_load())
            {
                $query_data = $DB->query("SELECT links_data 
                                FROM exp_mainlink_links
                                WHERE links_id = '".hexdec(crc32($this->uri))."'");

                $data_uri = unserialize($query_data->row['links_data']);
            }
            else
            {
                return;
            }
        }

        foreach($data_uri as $row)
        {
            $tagdata = $TMPL->tagdata;

            foreach ($TMPL->var_single as $key => $val)
            {
                if (isset($row[$val]))
                {
                    $tagdata = $TMPL->swap_var_single($val, $row[$val], $tagdata);
                }
            }

            $this->return_data .= $tagdata; 
        }
        return $this->return_data;
    }
}
?>